import { csv, select,legendColor } from 'd3';
import { scatterPlot } from './scatterPlot';


const csvUrl = [
  'https://gist.githubusercontent.com/AnanyaSamala/f30ad745fecdd656f0c371f74746392c/raw/2516a59148818095298721ae017948dd263347e3/storesales.csv', 
].join('');
const parseRow = (d) => {
  d.Sales = +d.Sales;
  d.Profit = +d.Profit;
  d.Sales = +d.Sales;
  d.Sales = +d.Sales;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const xValue = (d) => d.Sales;
const yValue = (d) => d.Profit;
const rxValue = (d) => d.Sales;
const ryValue = (d) => d.Profit;
const CategoryValue = (d) => d.Category;
const colorValue = d => d.Category;
const colorLabel = 'Category';


const main = async () => {
  const data = await csv(csvUrl, parseRow);
  const x = xValue((d) => d.Sales);
  const y = yValue((d) => d.Profit);
  const marker = (d) => {
        	switch(d){
            case 'Furniture':
              return 'orange';
            case 'Office Supplies':
              return 'blue';
            default:
              return 'black';
          }
        }
  
  const marks = data.map((d) => ({
          x: xValue((d) => d.Sales),
          y: yValue((d) => d.Profit),
          Category: CategoryValue(d),
          color: marker(CategoryValue(d)),
        	rx: rxValue(d),
          ry: ryValue(d),
                      
        }));
  
  
//Defining scatterplot structure
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.Sales)
    .yValue((d) => d.Profit)
    .margin({
      top: 35,
      right: 50,
      bottom: 80,
      left: 95,

    })
    .radius(5);
  
  
 const g = svg.append('g')
          .attr('transform', `translate(${100},${100})`);

      const colorLegendG = g.append('g')
          .attr('transform', `translate(${100}, 150)`);





//Defining the shape and structure of data points  
svg
          .selectAll('circle')
          .data(marks)
          .join('circle')
          .attr('cx', (d) => d.x)
          .attr('cy', (d) => d.y)
        	.attr('fill', (d) => d.color)
        	.attr('rx', (d) => (d.rx))
        	.attr('ry', (d) => (d.ry));

     
    
  
  const columns = [
    'Sales',
    'Profit',
   'Sales',
   'Profit',
  ];

  
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);  /* Generates  'Sales',
    'sepal_width',
    'Sales',
    'Profit'*/
		svg.selectAll('text').remove();
    svg.call(plot);
    
      colorLegendG.append('text')
          .attr('class', 'legend-label')
          .attr('x', -70)
          .attr('y', -210)
          .style("font-style","italic")
          .style("stroke","black")
          .text(colorLabel);

   
// Title
svg.append("text").attr("x", 450).attr("y", 20).text("StoreSales").style("font-size", "35px").attr("alignment-baseline","middle")

   
// Add labels in the legend
svg.append("text").attr("x", 150).attr("y", 70).text("Furniture").style("font-size", "20px").attr("alignment-baseline","middle")
svg.append("text").attr("x", 150).attr("y", 100).text("Office Supplies").style("font-size", "20px").attr("alignment-baseline","middle")
svg.append("text").attr("x", 150).attr("y", 130).text("Technology").style("font-size", "20px").attr("alignment-baseline","middle")
  
    svg
        	.append("text")
        	.attr('transform', 'rotate(-90)')
        	.attr('x',0 - (height /2))
        	.attr("y",  height/12)
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
        	.text("Profit");
    
    // Add points for legend
    svg.append("circle").attr("cx",130).attr("cy",70).attr("r", 6).style("fill", "orange")
		svg.append("circle").attr("cx",130).attr("cy",100).attr("r", 6).style("fill", "blue")
		svg.append("circle").attr("cx",130).attr("cy",130).attr("r", 6).style("fill", "black")
   // plot Sales on x-axis
    if(i % columns.length==0) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Sales");
     // plot profit on x-axis
    else if(i % columns.length==1) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Profit");
     // plot Sales on x-axis
    else if(i % columns.length==2) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Sales");
     // plot profit on x-axis
       else 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Profit");
    i++;
  }, 2000);// every 2 seconds change the visualization
};
main();



